## julia 1.0.1

=== Makefile ===
JULIAHOME := $(abspath $(dir $(lastword $(MAKEFILE_LIST))))
include $(JULIAHOME)/Make.inc

VERSDIR := v`cut -d. -f1-2 < $(JULIAHOME)/VERSION`

default: $(JULIA_BUILD_MODE) # contains either "debug" or "release"
all: debug release

# sort is used to remove potential duplicates
DIRS := $(sort $(build_bindir) $(build_depsbindir) $(build_libdir) $(build_private_libdir) $(build_libexecdir) $(build_includedir) $(build_includedir)/julia $(build_sysconfdir)/julia $(build_datarootdir)/julia $(build_datarootdir)/julia/stdlib $(build_man1dir))
ifneq ($(BUILDROOT),$(JULIAHOME))
BUILDDIRS := $(BUILDROOT) $(addprefix $(BUILDROOT)/,base src ui doc deps test test/embedding)
BUILDDIRMAKE := $(addsuffix /Makefile,$(BUILDDIRS))
DIRS := $(DIRS) $(BUILDDIRS)
$(BUILDDIRMAKE): | $(BUILDDIRS)
	@# add Makefiles to the build directories for convenience (pointing back to the source location of each)
	@echo '# -- This file is automatically generated in julia/Makefile -- #' > $@
	@echo 'BUILDROOT=$(BUILDROOT)' >> $@
	@echo 'include $(JULIAHOME)$(patsubst $(BUILDROOT)%,%,$@)' >> $@
julia-deps: | $(BUILDDIRMAKE)
configure-y: | $(BUILDDIRMAKE)
configure:
ifeq ("$(origin O)", "command line")
	@if [ "$$(ls '$(BUILDROOT)' 2> /dev/null)" ]; then \
		echo 'WARNING: configure called on non-empty directory $(BUILDROOT)'; \
		read -p "Proceed [y/n]? " answer; \
	else \
		answer=y;\
	fi; \
	[ $$answer = 'y' ] && $(MAKE) configure-$$answer
else
	$(error "cannot rerun configure from within a build directory")
endif
else
configure:
	$(error "must specify O=builddir to run the Julia `make configure` target")
endif

$(foreach dir,$(DIRS),$(eval $(call dir_target,$(dir))))
$(foreach link,base $(JULIAHOME)/test,$(eval $(call symlink_target,$(link),$(build_datarootdir)/julia,$(notdir $(link)))))

build_defaultpkgdir = $(build_datarootdir)/julia/stdlib/$(shell echo $(VERSDIR))
$(eval $(call symlink_target,$(JULIAHOME)/stdlib,$(build_datarootdir)/julia/stdlib,$(shell echo $(VERSDIR))))

julia_flisp.boot.inc.phony: julia-deps
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/src julia_flisp.boot.inc.phony

# Build the HTML docs (skipped if already exists, notably in tarballs)
$(BUILDROOT)/doc/_build/html/en/index.html: $(shell find $(BUILDROOT)/base $(BUILDROOT)/doc \( -path $(BUILDROOT)/doc/_build -o -path $(BUILDROOT)/doc/deps -o -name *_constants.jl -o -name *_h.jl -o -name version_git.jl \) -prune -o -type f -print)
	@$(MAKE) docs

julia-symlink: julia-ui-$(JULIA_BUILD_MODE)
ifneq ($(OS),WINNT)
ifndef JULIA_VAGRANT_BUILD
	@ln -sf "$(shell $(JULIAHOME)/contrib/relative_path.sh "$(BUILDROOT)" "$(JULIA_EXECUTABLE)")" $(BUILDROOT)/julia
endif
endif

julia-deps: | $(DIRS) $(build_datarootdir)/julia/base $(build_datarootdir)/julia/test $(build_defaultpkgdir)
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/deps

julia-base: julia-deps $(build_sysconfdir)/julia/startup.jl $(build_man1dir)/julia.1 $(build_datarootdir)/julia/julia-config.jl
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/base

julia-libccalltest: julia-deps
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/src libccalltest

julia-src-release julia-src-debug : julia-src-% : julia-deps julia_flisp.boot.inc.phony
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/src libjulia-$*

julia-ui-release julia-ui-debug : julia-ui-% : julia-src-%
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/ui julia-$*

julia-sysimg : julia-base julia-ui-$(JULIA_BUILD_MODE)
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT) $(build_private_libdir)/sys.ji JULIA_EXECUTABLE='$(JULIA_EXECUTABLE)'

julia-sysimg-release : julia-sysimg julia-ui-release
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT) $(build_private_libdir)/sys.$(SHLIB_EXT)

julia-sysimg-debug : julia-sysimg julia-ui-debug
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT) $(build_private_libdir)/sys-debug.$(SHLIB_EXT)

julia-debug julia-release : julia-% : julia-ui-% julia-sysimg-% julia-symlink julia-libccalltest julia-base-cache

debug release : % : julia-%

docs: julia-sysimg-$(JULIA_BUILD_MODE)
	@$(MAKE) $(QUIET_MAKE) -C $(BUILDROOT)/doc JULIA_EXECUTABLE='$(call spawn,$(JULIA_EXECUTABLE_$(JULIA_BUILD_MODE)))'

check-whitespace:
ifneq ($(NO_GIT), 1)
	@$(JULIAHOME)/contrib/check-whitespace.sh
else
	$(warn "Skipping whitespace check because git is unavailable")
endif

release-candidate: release testall
	@$(JULIA_EXECUTABLE) $(JULIAHOME)/contrib/add_license_to_files.jl #add license headers
	@#Check documentation
	@$(JULIA_EXECUTABLE) $(JULIAHOME)/doc/NEWS-update.jl #Add missing cross-references to NEWS.md
	@$(MAKE) -C $(BUILDROOT)/doc html doctest=true linkcheck=true
	@$(MAKE) -C $(BUILDROOT)/doc pdf

	@# Check to see if the above make invocations changed anything important
	@if [ -n "$$(git status --porcelain)" ]; then \
		echo "Git repository dirty; Verify and commit changes to the repository, then retry"; \
		exit 1; \
	fi

	@#Check that netload tests work
	@#for test in test/netload/*.jl; do julia $$test; if [ $$? -ne 0 ]; then exit 1; fi; done
	@echo
	@echo To complete the release candidate checklist:
	@echo

	@echo 1. Remove deprecations in base/deprecated.jl
	@echo 2. Update references to the julia version in the source directories, such as in README.md
	@echo 3. Bump VERSION
	@echo 4. Increase SOMAJOR and SOMINOR if needed.
	@echo 5. Create tag, push to github "\(git tag v\`cat VERSION\` && git push --tags\)"		#"` # These comments deal with incompetent syntax highlighting rules
	@echo 6. Clean out old .tar.gz files living in deps/, "\`git clean -fdx\`" seems to work	#"`
	@echo 7. Replace github release tarball with tarballs created from make light-source-dist and make full-source-dist
	@echo 8. Check that 'make && make install && make test' succeed with unpacked tarballs even without Internet access.
	@echo 9. Follow packaging instructions in DISTRIBUTING.md to create binary packages for all platforms
	@echo 10. Upload to AWS, update https://julialang.org/downloads and http://status.julialang.org/stable links
	@echo 11. Update checksums on AWS for tarball and packaged binaries
	@echo 12. Announce on mailing lists
	@echo 13. Change master to release-0.X in base/version.jl and base/version_git.sh as in 4cb1e20
	@echo

$(build_man1dir)/julia.1: $(JULIAHOME)/doc/man/julia.1 | $(build_man1dir)
	@echo Copying in usr/share/man/man1/julia.1
	@mkdir -p $(build_man1dir)
	@cp $< $@

$(build_sysconfdir)/julia/startup.jl: $(JULIAHOME)/etc/startup.jl | $(build_sysconfdir)/julia
	@echo Creating usr/etc/julia/startup.jl
	@cp $< $@

$(build_datarootdir)/julia/julia-config.jl : $(JULIAHOME)/contrib/julia-config.jl | $(build_datarootdir)/julia
	$(INSTALL_M) $< $(dir $@)

$(build_private_libdir)/%.$(SHLIB_EXT): $(build_private_libdir)/%-o.a
	@$(call PRINT_LINK, $(CXX) $(LDFLAGS) -shared $(fPIC) -L$(build_private_libdir) -L$(build_libdir) -L$(build_shlibdir) -o $@ \
		$(WHOLE_ARCHIVE) $< $(NO_WHOLE_ARCHIVE) \
		$(if $(findstring -debug,$(notdir $@)),-ljulia-debug,-ljulia) \
		$$([ $(OS) = WINNT ] && echo '' -lssp))
	@$(INSTALL_NAME_CMD)$(notdir $@) $@
	@$(DSYMUTIL) $@

COMPILER_SRCS := $(addprefix $(JULIAHOME)/, \
		base/boot.jl \
		base/docs/core.jl \
		base/abstractarray.jl \
		base/abstractdict.jl \
		base/array.jl \
		base/bitarray.jl \
		base/bitset.jl \
		base/bool.jl \
		base/ctypes.jl \
		base/error.jl \
		base/essentials.jl \
		base/expr.jl \
		base/generator.jl \
		base/int.jl \
		base/indices.jl \
		base/iterators.jl \
		base/namedtuple.jl \
		base/number.jl \
		base/operators.jl \
		base/options.jl \
		base/pair.jl \
		base/pointer.jl \
		base/promotion.jl \
		base/range.jl \
		base/reflection.jl \
		base/traits.jl \
		base/refvalue.jl \
		base/tuple.jl)
COMPILER_SRCS += $(shell find $(JULIAHOME)/base/compiler -name \*.jl)
# sort these to remove duplicates
BASE_SRCS := $(sort $(shell find $(JULIAHOME)/base -name \*.jl -and -not -name sysimg.jl) \
                    $(shell find $(BUILDROOT)/base -name \*.jl  -and -not -name sysimg.jl)) \
                    $(shell find $(JULIAHOME)/stdlib/Base64/src -name \*.jl)
STDLIB_SRCS := $(JULIAHOME)/base/sysimg.jl $(shell find $(JULIAHOME)/stdlib/*/src -name \*.jl)
STDLIB_PKGS := $(shell cd $(JULIAHOME)/stdlib && ls)
RELBUILDROOT := $(shell $(JULIAHOME)/contrib/relative_path.sh "$(JULIAHOME)/base" "$(BUILDROOT)/base/")

$(build_private_libdir)/corecompiler.ji: $(COMPILER_SRCS) | $(build_private_libdir)
	@$(call PRINT_JULIA, cd $(JULIAHOME)/base && \
	$(call spawn,$(JULIA_EXECUTABLE)) -C "$(JULIA_CPU_TARGET)" --output-ji $(call cygpath_w,$@).tmp \
		--startup-file=no -g0 -O0 compiler/compiler.jl)
	@mv $@.tmp $@

COMMA:=,
$(build_private_libdir)/sys.ji: $(build_private_libdir)/corecompiler.ji $(JULIAHOME)/VERSION $(BASE_SRCS) $(STDLIB_SRCS)
	@$(call PRINT_JULIA, cd $(JULIAHOME)/base && \
	if ! $(call spawn,$(JULIA_EXECUTABLE)) -g1 -O0 -C "$(JULIA_CPU_TARGET)" --output-ji $(call cygpath_w,$@).tmp $(JULIA_SYSIMG_BUILD_FLAGS) \
			--startup-file=no --warn-overwrite=yes --sysimage $(call cygpath_w,$<) sysimg.jl $(RELBUILDROOT); then \
		echo '*** This error might be fixed by running `make clean`. If the error persists$$(COMMA) try `make cleanall`. ***'; \
		false; \
	fi )
	@mv $@.tmp $@

define sysimg_builder
$$(build_private_libdir)/sys$1-o.a $$(build_private_libdir)/sys$1-bc.a : $$(build_private_libdir)/sys$1-%.a : $$(build_private_libdir)/sys.ji
	@$$(call PRINT_JULIA, cd $$(JULIAHOME)/base && \
	if ! $$(call spawn,$3) $2 -C "$$(JULIA_CPU_TARGET)" --output-$$* $$(call cygpath_w,$$@).tmp $$(JULIA_SYSIMG_BUILD_FLAGS) \
		--startup-file=no --warn-overwrite=yes --sysimage $$(call cygpath_w,$$<) $$(call cygpath_w,$$(JULIAHOME)/contrib/generate_precompile.jl); then \
		echo '*** This error is usually fixed by running `make clean`. If the error persists$$(COMMA) try `make cleanall`. ***'; \
		false; \
	fi )
	@mv $$@.tmp $$@
.SECONDARY: $$(build_private_libdir)/sys$1-o.a $(build_private_libdir)/sys$1-bc.a # request Make to keep these files around
endef
$(eval $(call sysimg_builder,,-O3,$(JULIA_EXECUTABLE_release)))
$(eval $(call sysimg_builder,-debug,-O0,$(JULIA_EXECUTABLE_debug)))

$(build_depsbindir)/stringreplace: $(JULIAHOME)/contrib/stringreplace.c | $(build_depsbindir)
	@$(call PRINT_CC, $(HOSTCC) -o $(build_depsbindir)/stringreplace $(JULIAHOME)/contrib/stringreplace.c)

julia-base-cache: julia-sysimg-$(JULIA_BUILD_MODE) | $(DIRS) $(build_datarootdir)/julia
	@$(call spawn,$(JULIA_EXECUTABLE) --startup-file=no $(call cygpath_w,$(JULIAHOME)/etc/write_base_cache.jl) \
		$(call cygpath_w,$(build_datarootdir)/julia/base.cache))

# public libraries, that are installed in $(prefix)/lib
JL_TARGETS := julia
ifeq ($(BUNDLE_DEBUG_LIBS),1)
JL_TARGETS += julia-debug
endif

# private libraries, that are installed in $(prefix)/lib/julia
JL_PRIVATE_LIBS-0 := libccalltest
ifeq ($(USE_GPL_LIBS), 1)
JL_PRIVATE_LIBS-0 += libsuitesparse_wrapper
JL_PRIVATE_LIBS-$(USE_SYSTEM_SUITESPARSE) += libamd libcamd libccolamd libcholmod libcolamd libumfpack libspqr libsuitesparseconfig
endif
JL_PRIVATE_LIBS-$(USE_SYSTEM_PCRE) += libpcre2-8
JL_PRIVATE_LIBS-$(USE_SYSTEM_DSFMT) += libdSFMT
JL_PRIVATE_LIBS-$(USE_SYSTEM_GMP) += libgmp
JL_PRIVATE_LIBS-$(USE_SYSTEM_MPFR) += libmpfr
JL_PRIVATE_LIBS-$(USE_SYSTEM_LIBSSH2) += libssh2
JL_PRIVATE_LIBS-$(USE_SYSTEM_MBEDTLS) += libmbedtls libmbedcrypto libmbedx509
JL_PRIVATE_LIBS-$(USE_SYSTEM_CURL) += libcurl
JL_PRIVATE_LIBS-$(USE_SYSTEM_LIBGIT2) += libgit2
ifeq ($(USE_LLVM_SHLIB),1)
JL_PRIVATE_LIBS-$(USE_SYSTEM_LLVM) += libLLVM libLLVM-6
endif

ifeq ($(USE_SYSTEM_OPENLIBM),0)
ifeq ($(USE_SYSTEM_LIBM),0)
JL_PRIVATE_LIBS-0 += $(LIBMNAME)
endif
endif

JL_PRIVATE_LIBS-$(USE_SYSTEM_BLAS) += $(LIBBLASNAME)
ifneq ($(LIBLAPACKNAME),$(LIBBLASNAME))
JL_PRIVATE_LIBS-$(USE_SYSTEM_LAPACK) += $(LIBLAPACKNAME)
endif

ifeq ($(OS),Darwin)
ifeq ($(USE_SYSTEM_BLAS),1)
ifeq ($(USE_SYSTEM_LAPACK),0)
JL_PRIVATE_LIBS-0 += libgfortblas
endif
endif
endif

# On FreeBSD, /lib/libgcc_s.so.1 is incompatible with Fortran; to use Fortran on FreeBSD,
# we need to link to the libgcc_s that ships with the same GCC version used by libgfortran.

=== doc/Makefile ===
# Makefile for building documentation

default: html

# You can set these variables from the command line.
SRCDIR           := $(abspath $(dir $(lastword $(MAKEFILE_LIST))))
JULIAHOME        := $(abspath $(SRCDIR)/..)
include $(JULIAHOME)/Make.inc
JULIA_EXECUTABLE := $(call spawn,$(build_bindir)/julia)

.PHONY: help clean cleanall html pdf deps deploy

help:
	@echo "Please use 'make <target>' where <target> is one of"
	@echo "  html  to make standalone HTML files"
	@echo "  pdf   to make standalone PDF file"
	@echo
	@echo "To run linkcheck, use 'make <target> linkcheck=true'"
	@echo "To run doctests, use 'make <target> doctest=true'"
	@echo "To fix outdated doctests, use 'make <target> doctest=fix'"


DOCUMENTER_OPTIONS := linkcheck=$(linkcheck) doctest=$(doctest)

UnicodeData.txt:
	$(JLDOWNLOAD) http://www.unicode.org/Public/9.0.0/ucd/UnicodeData.txt

deps: UnicodeData.txt
	$(JLCHECKSUM) UnicodeData.txt

clean:
	-rm -rf _build/* deps/* docbuild.log UnicodeData.txt

cleanall: clean

html: deps
	@echo "Building HTML documentation."
	$(JULIA_EXECUTABLE) --color=yes $(call cygpath_w,$(SRCDIR)/make.jl) $(DOCUMENTER_OPTIONS)
	@echo "Build finished. The HTML pages are in _build/html."

pdf: deps
	@echo "Building PDF documentation."
	$(JULIA_EXECUTABLE) --color=yes $(call cygpath_w,$(SRCDIR)/make.jl) -- pdf $(DOCUMENTER_OPTIONS)
	@echo "Build finished."

# The deploy target should only be called in Travis builds
deploy: deps
	@echo "Deploying HTML documentation."
	$(JULIA_EXECUTABLE) --color=yes $(call cygpath_w,$(SRCDIR)/make.jl) -- deploy $(DOCUMENTER_OPTIONS)
	@echo "Build & deploy of docs finished."

=== debian/changelog ===
julia (1.0.1-0ubuntu2) cosmic; urgency=medium

  [ Mo Zhou ]
  * Extend JULIA_CPU_TARGET to include optimized targets as well,
    apart from the generic target. (Closes: #910784)

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 15 Oct 2018 07:57:30 +0000

julia (1.0.1-0ubuntu1) cosmic; urgency=medium

  [ Graham Inggs ]
  * Sync with 1.0.1-1 from Debian binNEW
  * Skip DNS tests which fail on Ubuntu autopkgtest infrastructure  

  [ Mo Zhou ]
  * New upstream stable release 1.0.1 (Sept 2018)
  * Remove hundreds of patches picked from WIP Julia 1.0.1 release.
  * Elaborate on why debug info should not be stripped from sys.so in rules.
  * Drop deps:openspecfun which is not used anymore since 0.7 release.
  * Add CUSTOM_NATIVE variable in rules for custom builds.
  * Drop test related patches, because they are not needed anymore:
    - Drop test-add-envvar-for-skipping-network-tests.patch .
    - Drop test-moredetail.patch, test-skip-ppc64el-spec.patch
    - Drop test-remove-powermod.patch, test-aggressive-gc.patch .

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 02 Oct 2018 08:35:36 +0000

julia (1.0.0-3) unstable; urgency=medium

  * Handle floating point precision issue during test. (test-precision.patch)
  * Patch runtests.jl to let it print more detail. (test-moredetail.patch)
  * Make Documenter.jl quiet. (pre-apply, doc-silent.patch)
  * Autopkgtest: Skip network related tests for Ubuntu.
  * Link libjulia.so.X against netlib LAPACK (libblas.so.3/liblapack.so.3)
    in order to take advantage from alternatives system. (Closes: #905826)
  * Shared object libjulia.so.X Depends on high performance BLAS/LAPACK
    implementations when available, i.e. OpenBLAS | Atlas | Intel-MKL.
  * Add 167 patches from work-in-progress Julia 1.0.1 release.
  * Autopkgtest: Execute runtests.jl instead of calling Base.runtests()
  * README.Debian: Julia's BLAS/LAPACK backend is switchable henceforth.
  * Also remove the "net_on" guard in test/runtests.jl.
    (update, test-add-envvar-for-skipping-network-tests.patch)
  * Downgrade GCC version to 7 for armhf in order to circumvent FTBFS.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 23 Sep 2018 03:11:52 +0000

julia (1.0.0-2) unstable; urgency=medium

  * Run test on all architectures instead of only amd64 and i386,
    but allow non-x86 tests to fail. (Closes: #906754)
  * Binary package julia Suggests vim-julia. (Closes: #907050)
  * Enable the build on s390x
    - Disable libunwind on s390x (unsatisfiable dependency).
    * shlibdeps.mk: don't link against libunwind on s390x architecture.
    * Fix logic error in base/Makefile. (+ make-unwind-logic-error.patch)
  * Skip some tests unconditionally or conditionally according to Sys.ARCH
    * Skip "powermod" related tests on non-x86 architecture.
    * Skip several tests specifically on i386. (+ test-skip-i386-spec.patch)
    * Skip several tests on ppc64el. (+ test-skip-ppc64el-spec.patch)
    * Add patch test-add-envvar-for-skipping-network-tests.patch.
      + rules: Export DEBIAN_FORCE_NONET to skip network tests during build.
  * Add patch test-aggressive-gc.patch: make garbage collection aggressive.
  * Re-arrange patches and refresh them.
  * Disable thumb instruction set for armhf by adding -marm to cflags.
  * Bump Standards-Version to 4.2.1 (no change).
  * rules: Don't install extra license files.
  * Override false-positive lintian error: wrong-path-for-interpreter.
  * Upload to unstable.

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 14 Sep 2018 11:09:12 +0000

julia (1.0.0-1) experimental; urgency=medium

  * New upstream version 1.0.0
  * Bump SOVERSION from 0.7.0 to 1.0.0, update debian directory accordingly.
  * Package libjulia1.0 Breaks and Replaces libjulia0.7 .
  * Refresh symbols list for libjulia.so.1.0 .
  * Update the embedded Documenter:
    + Documenter.jl to v0.19.4
    + Compat.jl to v1.0.1 .
    + DocStringExtensions.jl to v0.4.6 .
    * Update debian/source/include-binaries accordingly.
    * Update patch privacy-breach.patch and pre-apply the patch.
  * Add patch doc-unicode-data-path.patch and update deb-make-doc.patch
    to avoid UnicodeData.txt File-Not-Found during documentation build.
  * Refresh debian/copyright.
  * Also build the PDF documentation apart from the HTML doc.
    + Add latex related Build-Depends-Indep packages for building PDF doc.
    + Override dh_auto_build-indep to build both HTML and PDF document.
    + Install the generated PDF doc doc/_build/pdf/en/TheJuliaLanguage.pdf
    + Register the PDF documentation in doc-base.
  * Remove source/local-options , not useful anymore.
  * Update appstream.patch from upstream pull request #28020.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 16 Aug 2018 07:48:17 +0000

julia (0.7.0-2) unstable; urgency=medium

  [ Peter Colberg ]
  * Drop Build-Depends on libfftw3-dev, Bindings to the FFTW library
    have been removed from Base. (Closes: #905849)

  [ Mo Zhou ]
  * Replace Sys.CPU_CORES with Sys.CPU_THREADS in test script.
  * Add patch test-skip-sigint.patch to temporarily avoid a random
    test failure in test/stress.jl, which sometimes fail to catch SIGINT.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 12 Aug 2018 01:00:36 +0000

julia (0.7.0-1) unstable; urgency=medium

  * New upstream version 0.7.0
  * Update embedded libuv tarball to ed3700c849289ed01fe04273a7bf865340b2bd7e.
  * Refresh all the patches.
  * Move privacy-breach.patch to quilt directory, and pre-apply the patch.
  * Require libgit2-dev (>= 0.27.0~) as B-D.
  * Bump Standards-Version to 4.2.0 (no change).
  * Three new symbols for libjulia0.7 0.7.0 .
  * Only traverse within debian directory when fixing shebang. (Avoid FTBFSx2)
  * README.Debian: Add brief instructions for rebuilding Julia against MKL.
  * Update file matching expressions in copyright.
  * Require llvm-6.0-dev (>= 1:6.0.1-3) in the B-D field.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 09 Aug 2018 16:43:05 +0000

julia (0.7.0~beta2-1) experimental; urgency=medium



=== debian/control ===
Source: julia
Section: science
Homepage: https://julialang.org
Priority: optional
Standards-Version: 4.2.1
Vcs-Git: https://salsa.debian.org/julia-team/julia.git
Vcs-Browser: https://salsa.debian.org/julia-team/julia
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Julia Team <pkg-julia-devel@lists.alioth.debian.org>
Uploaders: Peter Colberg <peter@colberg.org>,
           Graham Inggs <ginggs@debian.org>,
           Mo Zhou <cdluminate@gmail.com>,
Build-Depends:
 debhelper (>= 11),
 dpkg-dev (>= 1.16.2~),
 libcurl4-gnutls-dev | libcurl-dev,
 libdsfmt-dev (>= 2.2.3),
 libgit2-dev (>= 0.27.0~),
 libgmp-dev,
 libmpfr-dev,
 libblas-dev | libblas.so,
 libopenblas-dev [amd64 arm64 armhf i386 kfreebsd-amd64 kfreebsd-i386 mips64el ppc64el s390x],
 liblapack-dev | liblapack.so,
 libopenlibm-dev (>= 0.4.1+dfsg-4~) [any-i386 any-amd64 arm64 armhf mips mips64el mipsel powerpc ppc64 ppc64el],
 libpcre2-dev (>= 10.20-3~),
 libsuitesparse-dev (>= 1:4.4.5),
 libunwind8-dev [!s390x],
 libutf8proc-dev (>= 2.1.1),
 llvm-6.0-dev (>= 1:6.0.1-3),
 curl,
 unicode-data,
 libmbedtls-dev,
 gcc-7 [armhf], g++-7 [armhf],
Build-Depends-Indep:
 latexmk,
 texlive,
 texlive-extra-utils,
 texlive-fonts-extra,
 texlive-latex-base,
 texlive-latex-extra,
 texlive-latex-recommended,
 texlive-luatex,
 texlive-plain-generic,
 python-pygments,
 fonts-lato,

Package: julia
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: julia-common (= ${source:Version}),
         libjulia1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Replaces: julia-common (<< 0.5.0~)
Breaks: julia-common (<< 0.5.0~)
Suggests: ess (>= 12.09-1~), julia-doc, vim-julia,
Recommends: git
Description: high-performance programming language for technical computing
 Julia is a high-level, high-performance dynamic programming language for
 technical computing, with syntax that is familiar to users of other technical
 computing environments. It provides a sophisticated compiler, distributed
 parallel execution, numerical accuracy, and an extensive mathematical function
 library. The library, mostly written in Julia itself, also integrates mature,
 best-of-breed C and Fortran libraries for linear algebra, random number
 generation, FFTs, and string processing. Julia programs are organized around
 defining functions, and overloading them for different combinations of
 argument types (which can also be user-defined).
 .
 This package provides a complete Julia installation (JIT compiler, standard
 library, text-based user interface).

Package: libjulia1
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Replaces: julia (<< 0.5.0~), libjulia0.6, libjulia0.7
Breaks: julia (<< 0.5.0~), libjulia0.6, libjulia0.7
Depends: ${misc:Depends}, ${shlibs:Depends},
 libopenblas-base [amd64 arm64 armhf i386 kfreebsd-amd64 kfreebsd-i386 mips64el ppc64el s390x]
 | libatlas3-base [amd64 arm64 armel armhf hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel ppc64el s390x]
 | libmkl-rt [amd64 i386],
 libopenblas-dev [amd64 arm64 armhf i386 kfreebsd-amd64 kfreebsd-i386 mips64el ppc64el s390x]
 | libatlas-base-dev [amd64 arm64 armel armhf hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel ppc64el s390x]
 | libmkl-dev [amd64 i386],
Description: high-performance programming language for technical computing (runtime library)
 Julia is a high-level, high-performance dynamic programming language for
 technical computing, with syntax that is familiar to users of other technical
 computing environments. It provides a sophisticated compiler, distributed
 parallel execution, numerical accuracy, and an extensive mathematical function
 library. The library, mostly written in Julia itself, also integrates mature,
 best-of-breed C and Fortran libraries for linear algebra, random number
 generation, FFTs, and string processing. Julia programs are organized around
 defining functions, and overloading them for different combinations of
 argument types (which can also be user-defined).
 .
 This package provides the Julia runtime library.

Package: julia-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Replaces: julia (<< 0.4.1-1~)
Breaks: julia (<< 0.4.1-1~)
Recommends: julia
Description: high-performance programming language for technical computing (common files)
 Julia is a high-level, high-performance dynamic programming language for
 technical computing, with syntax that is familiar to users of other technical
 computing environments. It provides a sophisticated compiler, distributed
 parallel execution, numerical accuracy, and an extensive mathematical function
 library. The library, mostly written in Julia itself, also integrates mature,
 best-of-breed C and Fortran libraries for linear algebra, random number
 generation, FFTs, and string processing. Julia programs are organized around
 defining functions, and overloading them for different combinations of
 argument types (which can also be user-defined).
 .
 This package contains the Julia standard library and test suite.

Package: libjulia-dev
Section: libdevel
Architecture: any
Depends: libjulia1 (= ${binary:Version}), ${misc:Depends}
Description: high-performance programming language for technical computing (development)
 Julia is a high-level, high-performance dynamic programming language for
 technical computing, with syntax that is familiar to users of other technical
 computing environments. It provides a sophisticated compiler, distributed
 parallel execution, numerical accuracy, and an extensive mathematical function
 library. The library, mostly written in Julia itself, also integrates mature,
 best-of-breed C and Fortran libraries for linear algebra, random number
 generation, FFTs, and string processing. Julia programs are organized around
 defining functions, and overloading them for different combinations of
 argument types (which can also be user-defined).
 .
 This package provides the Julia runtime headers.

Package: julia-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         fonts-font-awesome,
         fonts-inconsolata,
         libjs-jquery,
         libjs-jquery-ui,
         libjs-mathjax,
         libjs-highlight.js,
         libjs-requirejs,
         libjs-lodash,
         node-normalize.css,
         node-highlight.js,
Suggests: julia
Description: high-performance programming language for technical computing (documentation)
 Julia is a high-level, high-performance dynamic programming language for
 technical computing, with syntax that is familiar to users of other technical
 computing environments. It provides a sophisticated compiler, distributed
 parallel execution, numerical accuracy, and an extensive mathematical function
 library. The library, mostly written in Julia itself, also integrates mature,
 best-of-breed C and Fortran libraries for linear algebra, random number
 generation, FFTs, and string processing. Julia programs are organized around
 defining functions, and overloading them for different combinations of
 argument types (which can also be user-defined).
 .
 This package contains the Julia manual, which describes the language and its
 standard library. It also contains example Julia programs.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND=-DLLVM_DISABLE_ABI_BREAKING_CHECKS_ENFORCING=0

# Disable unaligned access on armhf
ifneq (,$(filter $(DEB_HOST_ARCH),armhf))
	export DEB_CFLAGS_MAINT_APPEND += -mno-unaligned-access
endif

# Ensure pcre_h.jl and errno_h.jl are sorted reproducibly
export LC_ALL=C.UTF-8
# HOME is needed to avoid "mkdir(): Permission denied" while building docs.
# Some tests also need a HOME directory.
export HOME=/tmp
# If you want to do a custom build of Julia against MKL, set it to 1.
export CUSTOM_MKL ?= 0
# If you want to do a custom build for native machine architecture
export CUSTOM_NATIVE ?= 0
# Disable networking relates tests. (test-add-envvar-for-skipping-network-tests.patch)
export DEBIAN_FORCE_NONET="true"

LLVM_VER = $(shell grep -e 'llvm-.*-dev' debian/control | cut -d- -f2)

# NOTES:
# 1. Some of these flags come from upstream's Make.inc .
# 2. To enable USE_BLAS64=0 (ILP64), we need to set INTERFACE64=1 for OpenBLAS.
# 3. Julia is tightly coupled with a specific libuv1 version. we cannot use the one provided in archive.
# 4. ∴ is unicode "therefore", ⛬  is unicode "historic site" https://unicode-table.com/en/26EC/
COMMON_FLAGS = \
	prefix=/usr \
	sysconfdir=/etc \
	DESTDIR=debian/tmp/ \
	LLVM_CONFIG=/usr/bin/llvm-config-$(LLVM_VER) \
	LLVM_VER=$(LLVM_VER) \
	MULTIARCH=$(DEB_HOST_MULTIARCH) \
	MULTIARCH_INSTALL=1 \
	NO_GIT=1 \
	TAGGED_RELEASE_BANNER='$(DEB_VENDOR) ⛬  julia/$(DEB_VERSION)' \
	USE_BLAS64=0  \
	USE_LLVM_SHLIB=1 \
	USE_SYSTEM_BLAS=1 \
	USE_SYSTEM_CURL=1 \
	USE_SYSTEM_DSFMT=1 \
	USE_SYSTEM_GMP=1 \
	USE_SYSTEM_LAPACK=1 \
	USE_SYSTEM_LIBGIT2=1 \
	USE_SYSTEM_LIBSSH2=1 \
	USE_SYSTEM_LIBUNWIND=1 \
	USE_SYSTEM_LIBUV=0 \
	USE_SYSTEM_LLVM=1 \
	USE_SYSTEM_MBEDTLS=1 \
	USE_SYSTEM_MPFR=1 \
	USE_SYSTEM_OPENSPECFUN=1 \
	USE_SYSTEM_PATCHELF=1 \
	USE_SYSTEM_PCRE=1 \
	USE_SYSTEM_SUITESPARSE=1 \
	USE_SYSTEM_UTF8PROC=1 \
	LIBBLAS=-lblas \
	LIBBLASNAME=libblas \
	LIBLAPACK=-llapack \
	LIBLAPACKNAME=liblapack \
	VERBOSE=1

# Set architecture specific CPU targets. See: #910784
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 kfreebsd-amd64 x32))
COMMON_FLAGS += MARCH=x86-64 \
	JULIA_CPU_TARGET="generic;sandybridge,-xsaveopt,clone_all;haswell,-rdrnd,base(1)"
else ifneq (,$(filter $(DEB_HOST_ARCH),i386 hurd-i386 kfreebsd-i386))
COMMON_FLAGS += MARCH=pentium4 \
	JULIA_CPU_TARGET="pentium4;sandybridge,-xsaveopt,clone_all"
else ifneq (,$(filter $(DEB_HOST_ARCH),armhf))
COMMON_FLAGS += JULIA_CPU_TARGET="armv7-a;armv7-a,neon;armv7-a,neon,vfp4"
else
COMMON_FLAGS += JULIA_CPU_TARGET="generic"
endif

# Use libopenlibm on architectures that have it
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 kfreebsd-amd64 x32))
COMMON_FLAGS += USE_SYSTEM_OPENLIBM=1 USE_SYSTEM_LIBM=0
else ifneq (,$(filter $(DEB_HOST_ARCH),i386 hurd-i386 kfreebsd-i386))
COMMON_FLAGS += USE_SYSTEM_OPENLIBM=1 USE_SYSTEM_LIBM=0
else ifneq (,$(filter $(DEB_HOST_ARCH),arm64 armhf mips mips64el mipsel powerpc ppc64 ppc64el))
COMMON_FLAGS += USE_SYSTEM_OPENLIBM=1 USE_SYSTEM_LIBM=0
else
# Use libm elsewhere
COMMON_FLAGS += USE_SYSTEM_OPENLIBM=0 USE_SYSTEM_LIBM=1
endif

# [s390x] Disable libunwind
ifneq (,$(filter $(DEB_HOST_ARCH),s390x))
COMMON_FLAGS += DISABLE_LIBUNWIND=1
endif

# [armhf] Fallback to GCC-7
ifneq (,$(filter $(DEB_HOST_ARCH),armhf))
COMMON_FLAGS += CC=gcc-7 CXX=g++-7
endif

# Set number of parallel workers for tests
ifneq (,$(filter parallel=1,$(DEB_BUILD_OPTIONS)))
TESTS_ENV += JULIA_CPU_THREADS=2
else ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
TESTS_ENV += JULIA_CPU_THREADS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
TESTS_ENV += JULIA_CPU_THREADS=2
endif
# Restart workers exceeding maximum resident memory size (requires JULIA_CPU_THREADS >= 2)
TESTS_ENV += JULIA_TEST_MAXRSS_MB=500

ifeq (1,$(CUSTOM_MKL))
COMMON_FLAGS += USE_INTEL_MKL=1 USE_BLAS64=1 \
                LIBBLAS=-lmkl_rt LIBBLASNAME=libmkl_rt \
                LIBLAPACK=-lmkl_rt LIBLAPACKNAME=libmkl_rt \
				MKLROOT=/usr MKLLIB=/usr/lib/$(DEB_HOST_MULTIARCH)
endif
ifeq (1,$(CUSTOM_NATIVE))
COMMON_FLAGS += MARCH=native JULIA_CPU_TARGET=native
endif


%:
	dh $@

override_dh_auto_build-arch:
	dh_auto_build -- $(COMMON_FLAGS)

override_dh_auto_build-indep:
	dh_auto_build -- $(COMMON_FLAGS)
	-$(MAKE) -C doc pdf

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
	-env $(TESTS_ENV) make -C test $(COMMON_FLAGS)
else
	env $(TESTS_ENV) make -C test $(COMMON_FLAGS)
endif
endif

override_dh_auto_test-indep:

override_dh_auto_clean:
	make $(COMMON_FLAGS) distcleanall
	make -f debian/shlibdeps.mk $(COMMON_FLAGS) clean

override_dh_auto_install:
	make $(COMMON_FLAGS) install
	rm -rf usr # Otherwise dh_install does not see debian/tmp/usr
	find debian -type f -name '*.so.debug' -delete
	find debian -type f -name .gitignore -delete
	find debian -type f -name 'LICENSE.md' -delete

override_dh_missing:
	dh_missing --list-missing

override_dh_link-arch:
	# Create *.so symlinks for dlopen'd libraries in private libdir.
	make -f debian/shlibdeps.mk $(COMMON_FLAGS)
	dh_link

override_dh_shlibdeps:
	# Generate dependencies for dlopen'd libraries using dummy executable.
	# Suppress useless dependency warnings caused by unused library symbols.
	dh_shlibdeps -- --warnings=1 debian/shlibdeps

override_dh_compress:
	dh_compress --exclude=examples/

override_dh_install-indep:
	dh_install --exclude=build_h.jl --exclude=build.h

override_dh_fixperms:
	dh_fixperms
	# Fix shebang and mode bits
	find debian \( -type f -name '*.jl' \
		-exec grep -q '..usr/bin/env julia' '{}' \; \
		-a -exec sed -i -e 's@#!/usr/bin/env julia@#!/usr/bin/julia@g' '{}' \; \
		-a -exec chmod +x '{}' \; -print \)

# Don't strip sys.so and libjulia.so.* to keep the sanity of this program.
# https://github.com/JuliaLang/julia/issues/23115#issuecomment-320715030
#
# 0. What is sys.so, i.e. Julia sysimage?
#
#    sys.so is NOT compiled from any compiling language such as C/C++, but
#    from Julia scripts instead. Julia precompiles .jl scripts under the base
#    and stdlib directories into this ELF-formated shared object sys.so to
#    speedup program startup time. To some extent this is just like generating
#    ELF-formated cache for Julia base and stdlib. A glance at the symbol
#    table (readelf -sW sys.so) would suggest that sys.so is not an ordinary
#    ELF shared object as you thought.
#
# 1. What is the consequence of stripping sys.so?
#
#    Stripping sys.so will make julia behave differently from what the official
#    document says. stacktrace() won't trace into .jl files in base/stdlib.
#    That's because sys.so is compiled from .jl files instead of C/C++
#    sources and stripping sys.so results in the loss of debugging information
#    on .jl files. Julia interpreter itself is more likely a machine code
#    generator built upon LLVM. It is a bad idea to delete debugging
#    information about Julia's base/stdlib .jl files and confuse our users.
#
#    The consequence can be figured out after stripping sys.so by your self.
#    Just run julia following the official documentation:
#
#        https://docs.julialang.org/en/v1.0.0/manual/stacktraces/
#
#    And you will immediately find out that Julia is no longer able to give
#    you backtrace into the .jl files, which are precompiled into the sys.so.
#    If julia were python, this means python will nolonger able to trace
#    into e.g. python standard libraries (written in python) after stripping.
#
#    Stripping sys.so would also cause "backtrace" test failure, which is used
#    as sanity check.
#
#SYSIMG= debian/libjulia1/usr/lib/$(DEB_HOST_MULTIARCH)/julia/sys.so
override_dh_strip:
	dh_strip  -X"sys.so" -X"libjulia.so.1.0"
	#objcopy --only-keep-debug $(SYSIMG) $(SYSIMG).debug
	#strip $(SYSIMG)
	#objcopy --add-gnu-debuglink=$(SYSIMG).debug $(SYSIMG)

override_dh_makeshlibs:
